---
title: "Enrol a person in a course"
description: "\n\n### Quire permissions\n\nRequired capability: `enrol/manage`.\n\nCredential scopes: `enrolments:write`.\n\nThe acting subject must also be allowed to perform this action in the organisation."
image: "https://docs.quirelms.com/og.png"
---

> Documentation Index
> Fetch the complete documentation index at: https://docs.quirelms.com/llms.txt
> Use this file to discover all available pages before exploring further.

Path: Quire API › enrolments

`POST /enrolments`

\### Quire permissions

Required capability: `enrol/manage`.

Credential scopes: `enrolments:write`.

The acting subject must also be allowed to perform this action in the organisation.

## Authentication

Requires one of the following:

- `apiKey`, http, header `Authorization`, scopes: `enrolments:write`
- `oauth2`, oauth2, scopes: `enrolments:write`

## Header parameters

- `createEnrolment.header.Quire-Version` (string, optional) — The dated API revision to serve this request at. Omitted, the request is served at the revision the credential was issued against. The response echoes the revision actually applied.
  - format `date`
- `createEnrolment.header.Idempotency-Key` (string, optional) — A caller-chosen key making this request safe to retry. A replay of a completed request returns the recorded response with `Idempotency-Replayed: true`. Reusing a key for a different request is refused.
  - maxLength 255

## Request body

_Required._

- `createEnrolment.course_id` (string, required)
  - format `uuid`; pattern `^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$`
- `createEnrolment.user_id` (string, required)
  - format `uuid`; pattern `^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$`
- `createEnrolment.role_id` (string, optional) — A course role other than the manual method default.
  - format `uuid`; pattern `^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$`
- `createEnrolment.time_start` (string, optional)
  - format `date-time`; pattern `^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d:[0-5]\d(?:\.\d+)?(?:Z|([+-](?:[01]\d|2[0-3]):[0-5]\d)))$`
- `createEnrolment.time_end` (string, optional)
  - format `date-time`; pattern `^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d:[0-5]\d(?:\.\d+)?(?:Z|([+-](?:[01]\d|2[0-3]):[0-5]\d)))$`
- `createEnrolment.external_id` (string, optional)
  - minLength 1; maxLength 255

## Example request

```json
{
  "course_id": "5e757794-c815-4ccc-bf16-1010d8ef2347",
  "user_id": "a169451c-8525-4352-b8ca-070dd449a1a5",
  "role_id": "ac4e70c8-d5be-48af-93eb-760f58fc91a9",
  "time_start": "2019-08-24T14:15:22Z",
  "time_end": "2019-08-24T14:15:22Z",
  "external_id": "string"
}
```

## Code samples

### cURL

```curl
curl --request POST \
  --url https://your-organisation.quirelms.com/api/v1/enrolments \
  --header 'Authorization: Bearer <token>' \
  --header 'Content-Type: application/json' \
  --data '
{
  "course_id": "5e757794-c815-4ccc-bf16-1010d8ef2347",
  "user_id": "a169451c-8525-4352-b8ca-070dd449a1a5",
  "role_id": "ac4e70c8-d5be-48af-93eb-760f58fc91a9",
  "time_start": "2019-08-24T14:15:22Z",
  "time_end": "2019-08-24T14:15:22Z",
  "external_id": "string"
}
'
```

### TypeScript

```typescript
const url = 'https://your-organisation.quirelms.com/api/v1/enrolments';
const options = {
  method: 'POST',
  headers: {'Content-Type': 'application/json', Authorization: 'Bearer <token>'},
  body: JSON.stringify({
    course_id: '5e757794-c815-4ccc-bf16-1010d8ef2347',
    user_id: 'a169451c-8525-4352-b8ca-070dd449a1a5',
    role_id: 'ac4e70c8-d5be-48af-93eb-760f58fc91a9',
    time_start: '2019-08-24T14:15:22Z',
    time_end: '2019-08-24T14:15:22Z',
    external_id: 'string'
  })
};

fetch(url, options)
  .then(res => res.json())
  .then(json => console.log(json))
  .catch(err => console.error(err));
```

### Python

```python
import requests

url = "https://your-organisation.quirelms.com/api/v1/enrolments"

payload = {
    "course_id": "5e757794-c815-4ccc-bf16-1010d8ef2347",
    "user_id": "a169451c-8525-4352-b8ca-070dd449a1a5",
    "role_id": "ac4e70c8-d5be-48af-93eb-760f58fc91a9",
    "time_start": "2019-08-24T14:15:22Z",
    "time_end": "2019-08-24T14:15:22Z",
    "external_id": "string"
}
headers = {
    "Content-Type": "application/json",
    "Authorization": "Bearer <token>"
}

response = requests.post(url, json=payload, headers=headers)

print(response.text)
```

## Responses

### 201

Success.

#### Example

```json
{
  "id": "string",
  "external_id": "string",
  "course_id": "string",
  "user_id": "string",
  "enrol_instance_id": "string",
  "status": "active",
  "time_start": "string",
  "time_end": "string",
  "first_enrolled_at": "string",
  "created_at": "string",
  "updated_at": "string",
  "deleted_at": "string"
}
```

- `createEnrolment.response.201.id` (string, required)
- `createEnrolment.response.201.external_id` (string | null, required)
- `createEnrolment.response.201.course_id` (string, required)
- `createEnrolment.response.201.user_id` (string, required)
- `createEnrolment.response.201.enrol_instance_id` (string, required)
- `createEnrolment.response.201.status` (string, required)
  - one of `"active"`, `"suspended"`
- `createEnrolment.response.201.time_start` (any of, required)
  - any of: `string`, `null`
- `createEnrolment.response.201.time_end` (any of, required)
  - any of: `string`, `null`
- `createEnrolment.response.201.first_enrolled_at` (string, required) — RFC 3339 timestamp in UTC.
- `createEnrolment.response.201.created_at` (string, required) — RFC 3339 timestamp in UTC.
- `createEnrolment.response.201.updated_at` (string, required) — RFC 3339 timestamp in UTC.
- `createEnrolment.response.201.deleted_at` (any of, required)
  - any of: `string`, `null`

### 401

The credential is missing, malformed, expired or revoked.

#### Example

```json
{
  "type": "http://example.com",
  "title": "string",
  "status": 0,
  "code": "string",
  "category": "validation",
  "detail": "string",
  "request_id": "string",
  "errors": [
    {
      "path": "string",
      "code": "string",
      "detail": "string"
    }
  ],
  "retry_after": 0,
  "docs_url": "http://example.com"
}
```

- `createEnrolment.response.401.type` (string, required)
  - format `uri`
- `createEnrolment.response.401.title` (string, required)
- `createEnrolment.response.401.status` (integer, required)
- `createEnrolment.response.401.code` (string, required)
- `createEnrolment.response.401.category` (string, required)
  - one of `"validation"`, `"authentication"`, `"authorization"`, `"not_found"`, `"conflict"`, `"precondition"`, `"quota"`, `"rate_limit"`, `"upstream"`, `"internal"`
- `createEnrolment.response.401.detail` (string, required)
- `createEnrolment.response.401.request_id` (string, required)
- `createEnrolment.response.401.docs_url` (string, required)
  - format `uri`
- `createEnrolment.response.401.errors` (array<object>, optional)
  - `createEnrolment.response.401.errors.path` (string, required) — RFC 6901 JSON Pointer into the request body.
  - `createEnrolment.response.401.errors.code` (string, required)
  - `createEnrolment.response.401.errors.detail` (string, required)
- `createEnrolment.response.401.retry_after` (integer | null, optional)

### 403

The credential lacks the scope this operation requires, or the acting subject lacks the capability.

#### Example

```json
{
  "type": "http://example.com",
  "title": "string",
  "status": 0,
  "code": "string",
  "category": "validation",
  "detail": "string",
  "request_id": "string",
  "errors": [
    {
      "path": "string",
      "code": "string",
      "detail": "string"
    }
  ],
  "retry_after": 0,
  "docs_url": "http://example.com"
}
```

- `createEnrolment.response.403.type` (string, required)
  - format `uri`
- `createEnrolment.response.403.title` (string, required)
- `createEnrolment.response.403.status` (integer, required)
- `createEnrolment.response.403.code` (string, required)
- `createEnrolment.response.403.category` (string, required)
  - one of `"validation"`, `"authentication"`, `"authorization"`, `"not_found"`, `"conflict"`, `"precondition"`, `"quota"`, `"rate_limit"`, `"upstream"`, `"internal"`
- `createEnrolment.response.403.detail` (string, required)
- `createEnrolment.response.403.request_id` (string, required)
- `createEnrolment.response.403.docs_url` (string, required)
  - format `uri`
- `createEnrolment.response.403.errors` (array<object>, optional)
  - `createEnrolment.response.403.errors.path` (string, required) — RFC 6901 JSON Pointer into the request body.
  - `createEnrolment.response.403.errors.code` (string, required)
  - `createEnrolment.response.403.errors.detail` (string, required)
- `createEnrolment.response.403.retry_after` (integer | null, optional)

### 409

The request conflicts with the current state, with a previous use of the same idempotency key, or with a concurrent write.

#### Example

```json
{
  "type": "http://example.com",
  "title": "string",
  "status": 0,
  "code": "string",
  "category": "validation",
  "detail": "string",
  "request_id": "string",
  "errors": [
    {
      "path": "string",
      "code": "string",
      "detail": "string"
    }
  ],
  "retry_after": 0,
  "docs_url": "http://example.com"
}
```

- `createEnrolment.response.409.type` (string, required)
  - format `uri`
- `createEnrolment.response.409.title` (string, required)
- `createEnrolment.response.409.status` (integer, required)
- `createEnrolment.response.409.code` (string, required)
- `createEnrolment.response.409.category` (string, required)
  - one of `"validation"`, `"authentication"`, `"authorization"`, `"not_found"`, `"conflict"`, `"precondition"`, `"quota"`, `"rate_limit"`, `"upstream"`, `"internal"`
- `createEnrolment.response.409.detail` (string, required)
- `createEnrolment.response.409.request_id` (string, required)
- `createEnrolment.response.409.docs_url` (string, required)
  - format `uri`
- `createEnrolment.response.409.errors` (array<object>, optional)
  - `createEnrolment.response.409.errors.path` (string, required) — RFC 6901 JSON Pointer into the request body.
  - `createEnrolment.response.409.errors.code` (string, required)
  - `createEnrolment.response.409.errors.detail` (string, required)
- `createEnrolment.response.409.retry_after` (integer | null, optional)

### 422

The request was understood and its content is not valid. `errors` names each field.

#### Example

```json
{
  "type": "http://example.com",
  "title": "string",
  "status": 0,
  "code": "string",
  "category": "validation",
  "detail": "string",
  "request_id": "string",
  "errors": [
    {
      "path": "string",
      "code": "string",
      "detail": "string"
    }
  ],
  "retry_after": 0,
  "docs_url": "http://example.com"
}
```

- `createEnrolment.response.422.type` (string, required)
  - format `uri`
- `createEnrolment.response.422.title` (string, required)
- `createEnrolment.response.422.status` (integer, required)
- `createEnrolment.response.422.code` (string, required)
- `createEnrolment.response.422.category` (string, required)
  - one of `"validation"`, `"authentication"`, `"authorization"`, `"not_found"`, `"conflict"`, `"precondition"`, `"quota"`, `"rate_limit"`, `"upstream"`, `"internal"`
- `createEnrolment.response.422.detail` (string, required)
- `createEnrolment.response.422.request_id` (string, required)
- `createEnrolment.response.422.docs_url` (string, required)
  - format `uri`
- `createEnrolment.response.422.errors` (array<object>, optional)
  - `createEnrolment.response.422.errors.path` (string, required) — RFC 6901 JSON Pointer into the request body.
  - `createEnrolment.response.422.errors.code` (string, required)
  - `createEnrolment.response.422.errors.detail` (string, required)
- `createEnrolment.response.422.retry_after` (integer | null, optional)

### 429

A rate limit or a concurrency cap was reached. `Retry-After` says when to try again.

#### Example

```json
{
  "type": "http://example.com",
  "title": "string",
  "status": 0,
  "code": "string",
  "category": "validation",
  "detail": "string",
  "request_id": "string",
  "errors": [
    {
      "path": "string",
      "code": "string",
      "detail": "string"
    }
  ],
  "retry_after": 0,
  "docs_url": "http://example.com"
}
```

- `createEnrolment.response.429.type` (string, required)
  - format `uri`
- `createEnrolment.response.429.title` (string, required)
- `createEnrolment.response.429.status` (integer, required)
- `createEnrolment.response.429.code` (string, required)
- `createEnrolment.response.429.category` (string, required)
  - one of `"validation"`, `"authentication"`, `"authorization"`, `"not_found"`, `"conflict"`, `"precondition"`, `"quota"`, `"rate_limit"`, `"upstream"`, `"internal"`
- `createEnrolment.response.429.detail` (string, required)
- `createEnrolment.response.429.request_id` (string, required)
- `createEnrolment.response.429.docs_url` (string, required)
  - format `uri`
- `createEnrolment.response.429.errors` (array<object>, optional)
  - `createEnrolment.response.429.errors.path` (string, required) — RFC 6901 JSON Pointer into the request body.
  - `createEnrolment.response.429.errors.code` (string, required)
  - `createEnrolment.response.429.errors.detail` (string, required)
- `createEnrolment.response.429.retry_after` (integer | null, optional)

### 500

Something failed at our end. Quote `request_id` when reporting it.

#### Example

```json
{
  "type": "http://example.com",
  "title": "string",
  "status": 0,
  "code": "string",
  "category": "validation",
  "detail": "string",
  "request_id": "string",
  "errors": [
    {
      "path": "string",
      "code": "string",
      "detail": "string"
    }
  ],
  "retry_after": 0,
  "docs_url": "http://example.com"
}
```

- `createEnrolment.response.500.type` (string, required)
  - format `uri`
- `createEnrolment.response.500.title` (string, required)
- `createEnrolment.response.500.status` (integer, required)
- `createEnrolment.response.500.code` (string, required)
- `createEnrolment.response.500.category` (string, required)
  - one of `"validation"`, `"authentication"`, `"authorization"`, `"not_found"`, `"conflict"`, `"precondition"`, `"quota"`, `"rate_limit"`, `"upstream"`, `"internal"`
- `createEnrolment.response.500.detail` (string, required)
- `createEnrolment.response.500.request_id` (string, required)
- `createEnrolment.response.500.docs_url` (string, required)
  - format `uri`
- `createEnrolment.response.500.errors` (array<object>, optional)
  - `createEnrolment.response.500.errors.path` (string, required) — RFC 6901 JSON Pointer into the request body.
  - `createEnrolment.response.500.errors.code` (string, required)
  - `createEnrolment.response.500.errors.detail` (string, required)
- `createEnrolment.response.500.retry_after` (integer | null, optional)


Source: https://docs.quirelms.com/api/enrolments/createEnrolment/index.md
